unit km_Common;

interface

Uses
  Windows, SysUtils, Forms;

const
  MutexName = 'kmBattGraph_MUTEX';
  ClassName = 'TkmBattGraphForm';
  WindowName = 'kmBattGraph';

  MAX_MES = 512;
  DefaultFormTop = 16;
  DefaultFormLeft = 16;
  DefaultFormWidth = 160;
  DefaultFormHeight = 120;
  HeightMin =32;
  WidthMin = 32;
  DefaultWindowState = 0;
  TaskTrayMyMessage = 'kmBattGraphMyMes';
  NotifyTaskTrayMessage = 'kmBattGraphNotifyTaskTray';
  defaultStayInTaskTray = 1;
  defaultStayInTaskTrayAndHideAtRun = 0;
  defaultStayInTaskTrayAndOpenAtRun = 1;
  defaultShowStatusBar = 1;
  LeftSpace = 18;
  BottomSpace = 11;
  LogCharMax = 1024;
  defaultShowUnknownFactor1 = 0;
  defaultShowUnknownFactor2 = 0;
  defaultCloseByDoubleClick = 1;
  defaultOpenByDoubleClickAtTaskTray = 1;
  defaultCloseByDoubleClickAtTaskTray = 1;
  defaultShowExitMenuInTaskTray = 0;
  defaultStayOnTop = 0;
  defaultShowXAxis = 1;
  defaultShowYAxis = 1;

//
// ֐錾
//
function GetLastErrorStr(ErrorCode: Integer): String;
function GetVersionInfo(KeyWord: String): string;
procedure DebugLog(Instr: String);

implementation

//
// fobOp̕\/O쐬
//
procedure DebugLog(InStr: String);
var
  DebugLogBuffer: Array[0..LogCharMax - 1] of Char;
  hFile: THandle;
  LL: Integer;
  II: Integer;
  lpNumberOfBytesWritten: DWORD;
  FolderPath: String;
begin
  FolderPath := ExtractFileDir(Application.ExeName);
  LL := Length(Instr);
  if LL > LogCharMax then LL := LogCharMax;
  for II := 0 TO LL - 1 do begin
    DebugLogBuffer[II] := Instr[II + 1]
  end;
  // fobOEO݂ł̓G[\Ȃ
  // \ƃfobO^[Qbg̃G[ƕ킵
  // fobOɂȂ邽
  hFile := CreateFile(PChar(FolderPath + '\DebugLog.txt'), GENERIC_WRITE,
                      FILE_SHARE_READ + FILE_SHARE_WRITE, NIL,
                      OPEN_ALWAYS,
                      FILE_ATTRIBUTE_NORMAL, 0);
  SetFilePointer(hFile, 0, NIL, FILE_END);
  WriteFile(hFile, DebugLogBuffer, LL, lpNumberOfBytesWritten, nil);
  CloseHandle(hFile)
end;

//
// G[R[h𕶎ɕϊ
// G[R[hŕ\
//
function GetLastErrorStr(ErrorCode: Integer): String;
var
  LastErrorStr: Array[0..MAX_MES - 1] of Char; // G[ԍ𕶎ɂ
begin
  FormatMessage(Format_Message_From_System, Nil, ErrorCode,
                (SubLang_Default shl 10) + Lang_Neutral,
                LastErrorStr, MAX_MES, Nil);
  Result := '(' + IntToStr(ErrorCode) + ')' + LastErrorStr
end;

//
// st@Co[W擾
// http://msdn.microsoft.com/library/ja/default.asp?url=/library/ja/jpwinui/html/_win32_verqueryvalue.asp
//
// ͌ĂȂBŏɌ̏擾
// ₢킹Ɏgpł镶(KeyWord)͈ȉ̂Ƃ
//
// Comments, InternalName, ProductName,
// CompanyName, LegalCopyright, ProductVersion,
// FileDescription, LegalTrademarks, PrivateBuild,
// FileVersion, OriginalFilename, SpecialBuild
//
function GetVersionInfo(KeyWord: String): string;
var
  BufSize: DWORD;
  HWnd: DWORD;
  pBlock: Pointer;
  lpBuffer: Pointer;
  lpTemp: Pointer;
  dwBytes: Longword;
  II: DWORD;
begin
  result := '';
  // Kvȃobt@̃TCY𒲂ׂ
  BufSize := GetFileVersionInfoSize(PChar(Application.ExeName), HWnd);
  if BufSize > 0 then begin
    // m
    GetMem(pBlock, BufSize);
    try
      // pBlockwƂɃt@C̃o[W񃊃\[X擾
      GetFileVersionInfo(PChar(Application.ExeName), 0, BufSize, pBlock);
      // R[h擾
      VerQueryValue(pBlock, PChar('\VarFileInfo\Translation'),
                    lpBuffer, dwBytes);
      // R[h܂񂾖₢킹쐬
      // 816iɕϊ
      // '\StringFileInfo\hhhhhhhh\FileDescription'
      VerQueryValue(pBlock,
                    PChar('\StringFileInfo\' +
                    IntToHex(Integer(lpBuffer^) and $FFFF, 4) +
                    IntToHex((Integer(lpBuffer^) shr 16) and $FFFF, 4) +
                    '\' + KeyWord),
                    lpBuffer,
                    dwBytes);
      // dwBytes̐k܂ނǂ̖mȋLqȂ̂
      // dwBytes񐔃Rs[Ă݂ŌオNULLB
      II := 0;
      lpTemp := lpBuffer;
      while II < dwBytes do begin
        result := result + Char(lpTemp^);
        lpTemp := Pointer(Integer(lpTemp) + 1);
        II := II + 1
      end;
      // ̍ŌNulltĂ̂Ŏ
      result := Trim(Result)
    finally
      // 
      FreeMem(pBlock)
    end
  end
end;

end.
